#include <stdlib.h>
#include "glut.h"

/* ̂̒_̂RcW */
GLdouble vertex[][3] = {
    { -1.0, -1.0, -1.0 },
    {  1.0, -1.0, -1.0 },
    {  1.0,  1.0, -1.0 },
    { -1.0,  1.0, -1.0 },
    { -1.0, -1.0,  1.0 },
    {  1.0, -1.0,  1.0 },
    {  1.0,  1.0,  1.0 },
    { -1.0,  1.0,  1.0 }
};

/* ̖̂ʂ\钸_ԍ */
int face[][4] = {
    { 0, 1, 2, 3 },
    { 1, 5, 6, 2 },
    { 5, 4, 7, 6 },
    { 4, 0, 3, 7 },
    { 4, 5, 1, 0 },
    { 3, 2, 6, 7 }
};

/* ̖̂ʂ̐F */
GLdouble color[][3] = {
    { 1.0, 0.0, 0.0 },
    { 0.0, 1.0, 0.0 },
    { 0.0, 0.0, 1.0 },
    { 1.0, 1.0, 0.0 },
    { 1.0, 0.0, 1.0 },
    { 0.0, 1.0, 1.0 }
};

void resize( int w, int h )
{
    /* r[|[gϊ */
    glViewport( 0, 0, w, h );

    /* ϊs̐ݒ胂[h@@eϊ */
    glMatrixMode( GL_PROJECTION );

    /* eϊs̏iPʍsɂj */
    glLoadIdentity();

    /* eϊiej̐ݒ */
    gluPerspective( 30.0, ( (double)w / (double)h ), 1.0, 100.0 );

    /* ϊs̐ݒ胂[h@@fr[ϊ
       fr[ϊFfOϊCϊir[COϊj */
    glMatrixMode( GL_MODELVIEW );
}

void display( void )
{
    int i, j;

    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

    /* fr[ϊs̏iPʍsɂj
       fr[ϊFfOϊCϊir[COϊj */
    glLoadIdentity();

    /* ϊir[COϊj̐ݒ */
    gluLookAt( 0.0, 6.0, 10.0,   /* _ʒu */
               0.0, 0.0, 0.0,    /* ڈʒu */
               0.0, 1.0, 0.0 );  /* xNg */

    /* fOϊ̐ݒ */
    /* f̕sړ */
    glTranslated( 0.0, 0.0, 0.0 );
    /* f̉] */
    glRotated( 30.0, 0.0, 1.0, 0.0 );
    /* f̊gEk */
    glScaled( 1.0, 1.5, 2.0 );

    /* f̕` */
    glBegin( GL_QUADS );
    for( j = 0; j < 6; j++ ) {
        glColor3dv( color[j] );
        for( i = 0; i < 4; i++ ) {
            glVertex3dv( vertex[face[j][i]] );
        }
    }
    glEnd();

    glFlush();
}

void init( void )
{
    glClearColor( 1.0, 1.0, 1.0, 1.0 );
    glEnable( GL_DEPTH_TEST );
}

int main( int argc, char *argv[] )
{
    glutInitWindowPosition( 100, 100 );
    glutInitWindowSize( 400, 400 );
    glutInit( &argc, argv );
    glutInitDisplayMode( GLUT_RGBA | GLUT_DEPTH );
    glutCreateWindow( argv[0] );
    glutReshapeFunc( resize );
    glutDisplayFunc( display );
    init();
    glutMainLoop();
    return( 0 );
}
